operating system/kernel-
how processor knows wht we are doing? hardwoare communicares with software
Linux & Its benefits over other os.
Updation of Unix,Receptive to changes,modifications 
suggested by its users,linux born

it will need programs file manager, document editors,collaberated with programmers of MIT.
userfriendly but overshadowed by windsows
most widely used kernel,popularity gained and used by ubuntu,fedora,debian

benifits of linux-
offers free os unlike windows
anyone with programming knowledge can modify it
we dont need antivirus
stability and reliability
linux based server could run non stop without a reboot for years 
unix is the mother is of linux
unix designed for mainframe and used in enterprises
unix for developers servers environment but may have to pay for unix kernel while linux is free
unix clone of linux

Intro of linux

1.Linux distribution & Types of installation
-what is ld?
unix is os kernel used by profit & n profit organisations and programmers to create os to suit their individial requirement custom 0s
version are known as distributions-100s built for specific purpose ex webserver running or newtwork switch or ex android
linux distro
developers love archlinux
cent OS  most used linux free eneterprise class and based on redhat 
source based distro ie gentoo linux not for begibnners
linux mint 
ubuntu based in debian linux distribution

install linux-
usb stick-1
ubuntu iso or os file download
visit www.ubuntu.com/download/dekstop
2.software program install .iso linux files on the usb stick universal usb installeer and pendrivelinux.com free
select versio nand I click on format drive and then click create and you will get pop up msg and press yes, ubuntu .iso file moving to the system and then close

2 installation is live cd.
visit above link to download the .iso files burn them to cd and boot computer throug hoptical device
3.virtual isnatllatoion
 freedom to run another os at the same time. ex virtual box 
download ubuntu .iso file then download for oracle vm install 
configure virtual os to create new vm
os linux version ubuntu
memory allocated then create new harddisk creates vdi virtual disk 
 boot ubuntu on virtual box and install ubuntu and click download updates while installing and select erase disk 

Testing a distribution-----
u can try ubuntu in trial mode and can check the interface if u like it or not

summary-
an os based on linux kernel is distribution or distro
1.100 of distro designed for sole purposes like running servers and nw switches
installation of linux using above 3 methods





Big switch to linux---
intro linux os and comapre with windows
windsows file saved in cde
in linux saved in directories and subdirectories 
root/

types of file in linux
everything is file 
1 general file-contain image video program ascii or binary format 
2.directory files is warehouese of file type directory file within ga directory
folders in windows os
system and program file in system in linux while in c drive in windows
3device file
d e g h 
in liunx drives are files
all device file reside in dev directory in linux

Users in linux
1/regular ruser
dont have access to directories of other useers
2 root ussers can access restrited file also called super user for administrative priviledges
3.service useser
services suc as apache and squid increases security of computer 
wont see service accounts in ubuntu dekstop version bu ti nubuntu server edition,regual raccounts are called standard accounts in ubuntu dekstop

file name convention-
windowns no 2 same name i nwindsows
but we can have same name in same directory provided at two different places cocnept 

Home directory

Summar- unix/linux use a tree like hierarchial file system
2no drives in linux unlike windows
3/peripherals like harddrives,cd rom printers are also considered files in linux/unix

3 types of user account
file convention is case sensitive above given




Terminal vs File Manger
1.frequent task on computer is 
browser
creating moving and deleting files

how to manage file?
command line interface (cli)
2.gui ie file manager prefereably

why cli?
flexible and options not avalible in gui
2. perform more with just 1 command
3. work on multiple files at a time using regular expression in cli
4.cli loads fast and dont consume ram

gui is impr
1.edit images and videos
2.cli challenging

launch cli on ubuntu
2 methods
1.dash-type terminal-ctrl alt t
understanding default cli
guru99@virtualbox:_$
username computer anme seperator home directory
dollar is regualr user
sign for root user is # sign

present working directory--
directory currently browsing
or use pwd command on terminal
we are in home guru 99 directory
pwd-print working directory

changing directory
cd /tmp
home to tmp directory

cd /bin to move to bin directory

Navigate to home directory
cd/cdtilt

cd/-to home directory

root/ or C:\ 

cd tilt -move to home direct
cd  / move to hoem directory
space bw cd and /


navigating--
cpu/dev
1.cd /dev-home to cpu direct under dev
2. cd .. -cpu to dev directory

path and its types---
it is address of a file or folder
2 kinds of paths -
absolute and relative
cd /home/guru99/pictures---absolute path as full path decribed

pwd
cd /pictures ---- realtive path


summary----\
manage file use clu or gui ie file manager or terminal in linux
launch ctrl alt t 
pwd gives present working directory
cd command to change directory
absolute and relative path

cd directory name- navigate to particual rdirectory
cd or cd tilte
to navigate to home direc
cd/
to root directory 
cd..


Important Linux Commands----
Listing files
ls
Display files in the current directory
directories in blue and files in white

Listing subdirectories /files

ex- Mp3 file song mp3

ls -R command 
ls -al details
file types and access permissions,menory blocks owner of file.uders groum,size in bytes,date and time


viewing hidden files----
hidden files start wih '.' period symbol
ls -a


creating and viewing files

cat command display text files and used to copy create combine new text files 

create new file-cl

cat > file 1
add content

press cntrl plus D
to view same file type cat file name
combine two files cat file name 1 file name 2 > new file press enetr
but no result because termianl is silent type it will show msg if error is tehre

cat newfile in cl 

deleting files---
rm fileanme

type ls
type rm test 
press ls 
test deleetd

Moving files
mv file name path
move command need superuser permisssion to overcome use comman sudo
sudo mainatin software log
15mins per teminal password retained

mv filename new file anme-rename files
ls
mv test test1
ls
creating directory--
mkdir directory name
mkdir songs
ls
create directory in new location--
mkdir /tmp/music
ls /tmp
 create multiple directory--
mkdir dierctory dierec direct1
ls
created under home directory

remove directory 
rmdir direct1-delet subdirectories first if present

Man command
stands for manual
reference book for linuc
simikar to help file

eg-
man ls
terminal give ls command detailss

history command
commands use in past
history

clear command-
cleans the terminal
51 minutes

Copy paste command

phone pictures-:


file permissions on linux-

linux is multi user so vital to save data to be corrupted
so authroisation levels are-
1.ownership
2.permissiom
1.assigned 3 types of owner of every file-the ones who created a file
group-contains multiple users-all users have same file access permission
other-doesnt own the file doesnt belog to usergroup
 how linux distinguishes bw these 3 files??
permissions system on linux-3 permissions read,write & execute
read-open and read a file,ability to list it contents
write-gives permission to add remove and rename files 
execute permission- exe should be set otherwise error we cant run the file

ex- r,w,x,- no permission
d directory

changing file/directory permisiions-
chmod permissions filename
-stands for change mode
2 modes-absolute( no characters free digit octal  check phome)& symbolic mode(use mathematical sysmbols to modify ) phone picture

chnging owner ship of files or directory---
 phone

tips on usergroups--
file /etc/group/ 
all the groups defined in system
filesystem-etc directory click and see all groups
- command groups
command newgrp
2 groups cant own same file
summary-
phone



print,email & install software on linux------

pr command-print files
pr command options o nphone-
print hardcopy
lp filename or lpr n filename
for multiple printers check phone
install softwares-
sending emails-install paclgage
sudo apt-get install mailx

sysntax
mailx abc@mail.com
enter subject
body
sumamary--phone

Redirection in Linux----

input device keyboard
output device screen
stdin and stdout
output redirection--
> symbol
eg
ls -al
ls -al > listings
echo hello > listings
cat listings 
>> adding content
<-- mail program linux help send email throug hterminal

file descriptors---
every file has a number called FD
Error redirection-
routing errors to file other than screen
any program or command executed 3 files open  
standard input,output,error
FD0,FD1,FD2  
imp feature
1.searching for files typically gets permission denied errors
2.error messages clutter up rogram output while executing shell scripts
solution-redirect error msgs
telnet localhost-run telnet
using find statement

linux pipe,grep,sort command------

|---pipe
run 2 commands cosnecutively
we can scroll the content of the file
reading file-phone

search a file for a text---
grep <search string>
cat fruits | grep avacdo
phone

sort command--
alphabetically
cat fruits
sort fruits

filters--
output of 1 command gos to inpu of 2 nd command

regualr expressions---
special characters
healp search data and mact hcomplex patters\
interval regular expressions-
tells about no of occurences of a charatcter in a string
 extended regular expression
brace expression use echo command {}-- phone 
summary ppone


Environmental variables----\
computing envirnment?
platform=os+processor
1.30.58*Environment Variables

-Dynamic Values
-exist in every OS and can be created,edited,saved & deleted
-gives information about the system behavior and can change the behavior of the program or software as well if changed.
-ex- $Lang & phone

**How to access variable values?
-using command echo $VARIABLE

** Create own user defined variable
- using command VARIABLENAME=variablevalue
** Deleting Variables
- Using command unset<VARIABLENAME>
** Set value of an environment variable
- using command export Variable=value

**What is Computing Environment?
-Platform=Operating system + Processor(Here user can run programs)
What is a variable?
-Location for storing a value & related to OS
-It can be filename,text,number or any other data
-Given a symbolic name
-value stored can be displayed,edited & resaved

*FTP,SSH,Ping in Linux
**Communication in Linux
-basic utilities needed to communicate with networks,other Linux systems & remote users.

***Ping
-Connection with the server is healthy or not
-Analyzing network and host connections
-Tracking network performance and managing it
-Testing hardware and software issues.
-Command
ping<ip-address or hostname>

***FTP(File Transfer Protocol)

-Logging in & establishing a connection with a remote host.
-Upload & download files
-Navigating through Directories
-Browsing contents of the directories.
-Command phone
ftp <ip-address or hostname>

***Telnet
-Connect to remote linux computer
-run programs remotely and conduct administration
-Similar to remote dekstop found in windows machine.
-Command
telnet <ip-address or hostname>

***SSH
-Secure shell securely connect to remote computer
-It is more secure than Telnet as additional certificates & passwords are encrypted.
-Command executed in remote computer

SSH username@ip-address or hostname

*Managing processes in Linux

-An instance of a program is process which is started when we give command to linux machine.
-Types of Processes
Foreground Processes & Background Processes-Start the program,Execute  press ctrl+Z,then type bg to send process to background

***FG Command
-used to continue a program which is stopped and can bring it to foreground
-Command
fg (jobname)

***Nice
-The priority index of a process is called Nice in Linux.
-Default value is 0 and can vary between 20 to -19.
-Niceness Index is indirectly proportional to priority given to the task. 
-Command phone
nice -n'Nice value' process name
renice 'nice value' -p 'PID'

*VI Editor
-most popular and commonly used linux text editor.
-available in all Linux distributions.
-Works in two modes,Command and Insert.
-Command mode takes the user commands and the insert mode is for editing text.
-to work on a file command should be known.
-this editor helps in creating scripts and editing files.
-Examples are Vi improved,elvis,nvi,vile,nano etc.
-Insert mode-: press 'i' ,after that any key would be taken as input.
-To start Vi Editor open terminal,
-Command
vi <filenameNEW> or vi <filenameExisting>
-Command mode(Default) -Tilde symbols denote unused lines.
-To see file jump to the command mode you cant see file content in insert mode.
-file displayed at the end of the tildes,to enter content press 'i'
see pone
-To save or close file use only command mode.
commands pone
shift +zz to return to the terminal

*Shell Scripting

-Kernel is the nucleus of the OS and it communicates between hardware and software.
-Shell is a program which interprets user commands through CLI like terminal.
-Bourn and C shells are mostly used shells in linux.
-Bourn shell-: '$'
-derivatives are POSIX Shell known as sh,Korn shell known as sh,Bourne again shell known as bash.
-C shell-: '%'
- known as csh
-Top C shell known as tcsh.
-Shell scripting is writing a series of command for the shell to execute.
-It can help to create complex programs containing conditional statements,loops and functions.
-Shell variables store the value of a string or a number for the shell to read.
-Creating a Shell script-:
-Create file using text editor like vi,name script file with extension .sh ,start the script with #!/bin/sh , write some code,save the script file as filename.sh.
- #! known as shebang is a operator directs scripts to interpreteter location.
-Adding comments to shell use # comment

*Introduction to Perl
-general purpose programming language designed for text editing
-Here we can create programs,handle databases and emails,GUI development and can use for Network & System administration
-Perl vs Shell
-perl doesnt cause portability issues.
-Error handling easy on perl
-we can write long and complex program on perl easily
-3 types of variables in pearl scalar,lists & hashes.
-Shell has fewer reusuable libraries available.
-Shell is less secure.

*create peral script
-create a file using editor like vi.
-name script file with extension .pl.
- Start with #!/usr/bin/perl
-write some code
-save the script file as filename.pl.
-For executing script write bash filename.pl.
-pone
-every statement end with semicolon

*Virtual Terminals

-ClIs which execute the user commands.
-6 virtual terminals can be launched using shortcut keys.
-offer multi user environment and upto 6 users can work at the same time.
-Cant use mouse with VTs.To launch press ctrl+alt+F(1to6)
-to return to homescreen of linux system press ctrl+alt+F7

*Linux Administration
-Handle user accounts,every individual is assigned user account to handle files,data and data. we can create multiple users and disable or delete it too.You can use both GUI or Terminal for user administration.pone
-Finger 
gives info about particular user